program recomp_donnees_bamber
  implicit none

  integer,parameter :: nx= 301          ! nombre de noeuds selon x (nb colonnes)
  integer,parameter :: ny= 561          ! nombre de noeuds selon y (nb lignes)
  integer,parameter :: pasx = 5000      ! pas selon x : 5km
  integer,parameter :: pasy = 5000      ! pas selon y : 5km

  integer i,j                           ! entiers de boucle

  real,dimension(nx,ny) :: Surf         ! matrice contenant l'altitude de surface
  real,dimension(nx,ny) :: Bed          ! matrice contenant l'altitude du socle
  real,dimension(nx,ny) :: Thick        ! matrice contenant l'epaisseur de la glace

  integer xi                               ! position selon x (en metre) dans la projection
  integer yj                               ! position selon y (en metre) dans la projection
  integer xmin                             ! coin inferieur gauche, selon x
  integer ymin                             ! coin inferieur gauche, selon y

  character(len=55) :: dir_input
  character(len=55) :: dir_output
  dir_input='/pc96/work250g/aquiquet/DATA/BASE_PROPRE/IN_OUTPUT'
  dir_output='/pc96/work250g/aquiquet/DATA/BASE_PROPRE/IN_OUTPUT'

700 format(10(f9.1))                  ! fichiers originels composes de lignes de 10 elements
800 format(2(i4),2(i7),f9.1)
900 format(2(i7),f9.1)

  open(20, file=trim(dir_input)//'/IN_INIT/surface_5km_corrected.txt',form='formatted',status='old')
  do j=1,ny                             ! on boucle sur le nombre de ligne 
     read(20,700) Surf(:,j)                ! pour eviter la ligne avec un seul element
  end do
  close(20)

  open(21, file=trim(dir_input)//'/IN_INIT/bed_5km_corrected.txt', form='formatted',status='old')
  do j=1,ny
     read(21,700) Bed(:,j)
  end do
  close(21)

  open(22, file=trim(dir_input)//'/IN_INIT/thick_5km_corrected.txt',form='formatted',status='old')
  do j=1,ny
     read(22,700) Thick(:,j)
  end do
  close(22)

  ! on cree les nouveux fichiers :
  ! type matrice :
  open(30, file=trim(dir_output)//'/TEMP/bamber_surface_mat.txt',form='formatted',status='unknown')
  open(31, file=trim(dir_output)//'/TEMP/bamber_bed_mat.txt',form='formatted',status='unknown')
  open(32, file=trim(dir_output)//'/TEMP/bamber_thick_mat.txt',form='formatted',status='unknown')
  do j=1,ny
     write(30,*) Surf(:,j)
     write(31,*) Bed(:,j)
     write(32,*) Thick(:,j)
  enddo
  close(30)
  close(31)
  close(32)

  ! type ijxyz
  open(40, file=trim(dir_output)//'/TEMP/bamber_surface_ijxyz.txt',form='formatted',status='unknown')
  open(41, file=trim(dir_output)//'/TEMP/bamber_bed_ijxyz.txt',form='formatted',status='unknown')
  open(42, file=trim(dir_output)//'/TEMP/bamber_thick_ijxyz.txt',form='formatted',status='unknown')
  xmin = -800000
  ymin = -3400000
  do j=1,ny
     do i=1,nx
        xi=xmin+(i-1)*pasx
        yj=ymin+(j-1)*pasy
        write(40,800) i,j,xi/1000,yj/1000,Surf(i,j)
        write(41,800) i,j,xi/1000,yj/1000,Bed(i,j)
        write(42,800) i,j,xi/1000,yj/1000,Thick(i,j)
     enddo
  enddo
  close(40)
  close(41)
  close(42)

  ! type xyz
  open(50, file=trim(dir_output)//'/TEMP/bamber_surface_xyz.txt',form='formatted',status='unknown')
  open(51, file=trim(dir_output)//'/TEMP/bamber_bed_xyz.txt',form='formatted',status='unknown')
  open(52, file=trim(dir_output)//'/TEMP/bamber_thick_xyz.txt',form='formatted',status='unknown')
  xmin = -800000
  ymin = -3400000
  do j=1,ny
     do i=1,nx
        xi=xmin+(i-1)*pasx
        yj=ymin+(j-1)*pasy
        write(50,900) xi/1000,yj/1000,Surf(i,j)
        write(51,900) xi/1000,yj/1000,Bed(i,j)
        write(52,900) xi/1000,yj/1000,Thick(i,j)
     enddo
  enddo
  close(50)
  close(51)
  close(52)

end program recomp_donnees_bamber

